import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Centripetal here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Centripetal extends Actor
{
    public static final int IMAGE_LENGTH = 1000;
    private double force;
    private double mass;
    private double velocity;
    private double radius;
    private double period;
    private int variable; //0=force, 1=mass, 2=velocity, 3=radius
    private double angle;
    private GreenfootImage image;
    
    private Variable F;
    private Variable M;
    private Variable V;
    private Variable R;
    
    public Centripetal(double mass, double velocity, double radius, Variable F, Variable M, Variable V, Variable R)
    {
        this.mass = mass;
        this.velocity = velocity;
        this.radius = radius;
        period = 2*Math.PI/velocity;
        force = mass*velocity*velocity/radius;
        variable = 0;
        angle = 0;
        draw();
        
        this.F = F;
        this.M = M;
        this.V = V;
        this.R = R;
    }
    
    public void act() 
    {
        double angleChange = velocity*360/(2*Math.PI*radius);
        angle += angleChange;
        if(angle >=  360) {angle = angle%360;}
        draw();
    }
    
    public double getForce() {return force;}
    public double getMass() {return mass;}
    public double getVelocity() {return velocity;}
    public double getRadius() {return radius;}
    public double getPeriod() {return period;}
    public int getVariable() {return variable;}
    
    public void setVariable(int variable) {this.variable = variable;}
    
    public void setForce(double force)
    {
        if(variable == 0) {return;}
        this.force = force;
        if(variable == 1) {fixMass(); return;}
        if(variable == 2) {fixVelocity(); return;}
        if(variable == 3) {fixRadius(); return;}
    }
    
    public void setMass(double mass)
    {
        if(variable == 1) {return;}
        this.mass = mass;
        draw();
        if(variable == 0) {fixForce(); return;}
        if(variable == 2) {fixVelocity(); return;}
        if(variable == 3) {fixRadius(); return;}
    }
    
    public void setVelocity(double velocity)
    {
        if(variable == 2) {return;}
        this.velocity = velocity;
        if(variable == 0) {fixForce(); fixPeriod(); return;}
        if(variable == 1) {fixMass(); fixPeriod(); return;}
        if(variable == 3) {fixRadius(); fixPeriod(); return;}
    }
    
    public void setRadius(double radius)
    {
        if(variable == 3) {return;}
        this.radius = radius;
        draw();
        if(variable == 0) {fixForce(); return;}
        if(variable == 1) {fixMass(); return;}
        if(variable == 2) {fixVelocity(); return;}
    }
    
    private void fixForce()
    {
        force = mass*velocity*velocity/radius;
        F.setValue(force);
    }
    
    private void fixMass()
    {
        mass = force*radius/(velocity*velocity);
        draw();
        M.setValue(mass);
    }
    
    private void fixVelocity()
    {
        velocity = Math.sqrt(force*radius/mass);
        fixPeriod();
        V.setValue(velocity);
    }
    
    private void fixRadius()
    {
        radius = mass*velocity*velocity/force;
        draw();
        R.setValue(radius);
    }
    
    private void fixPeriod()
    {
        period = 2*Math.PI*radius/velocity;
    }
    
    private void draw()
    {
        image = new GreenfootImage(IMAGE_LENGTH, IMAGE_LENGTH);
        image.setColor(Color.BLACK);
        image.drawLine(IMAGE_LENGTH/2, IMAGE_LENGTH/2, getPoint().getX(), getPoint().getY());
        image.setColor(Color.RED);
        image.fillOval(getPoint().getX()-((int)mass)/2, getPoint().getY()-((int)mass)/2, (int)mass, (int)mass);
        setImage(image);
        
        //F.draw();
        //M.draw();
        //V.draw();
        //R.draw();
    }
    
    private Point getPoint()    //returns the point where the blob is
    {
        int x = IMAGE_LENGTH/2+(int)(radius*Math.cos(angle));
        int y = IMAGE_LENGTH/2+(int)(radius*Math.sin(angle));
        return new Point(x,y);
    }
}