import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Plain here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Plain extends World
{

    /**
     * Constructor for objects of class Plain.
     * 
     */
    public Plain()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(700, 600, 1);       
        draw();
        
        Variable force = new Variable("F", 0.00065, 0.0, 0.002, 0.0001, 0);
        Variable mass = new Variable("M", 13.0, 0.0, 30.0, 1.0, 1);
        Variable velocity = new Variable("V", 0.1, 0.0, 0.5, 0.01, 2);
        Variable radius = new Variable("R", 200.0, 10.0, 200.0, 8.0, 3);
        
        ControlButton fcb1 = new ControlButton(force, false);
        ControlButton fcb2 = new ControlButton(force, true);
        ControlButton mcb1 = new ControlButton(mass, false);
        ControlButton mcb2 = new ControlButton(mass, true);
        ControlButton vcb1 = new ControlButton(velocity, false);
        ControlButton vcb2 = new ControlButton(velocity, true);
        ControlButton rcb1 = new ControlButton(radius, false);
        ControlButton rcb2 = new ControlButton(radius, true);
        
        CheckBox fc = new CheckBox(true);
        CheckBox mc = new CheckBox(false);
        CheckBox vc = new CheckBox(false);
        CheckBox rc = new CheckBox(false);
        
        CheckBox[] array = {fc, mc, vc, rc};
        
        Centripetal centripetal = new Centripetal(13.0, 0.1, 200.0, force, mass, velocity, radius);
        
        Controller controller = new Controller(array, centripetal);
        
        force.setCentripetal(centripetal);
        mass.setCentripetal(centripetal);
        velocity.setCentripetal(centripetal);
        radius.setCentripetal(centripetal);
        
        addObject(centripetal, 350, 380);
        
        addObject(force, 280, 130); addObject(fcb1, 255, 150); addObject(fcb2, 275, 150); addObject(fc, 295, 150);
        addObject(mass, 360, 130); addObject(mcb1, 344, 150); addObject(mcb2, 364, 150); addObject(mc, 384, 150);
        addObject(velocity, 410, 105); addObject(vcb1, 440, 101); addObject(vcb2, 460, 101); addObject(vc, 480, 101);
        addObject(radius, 410, 155); addObject(rcb1, 440, 151); addObject(rcb2, 460, 151); addObject(rc, 480, 151);
        
        Greenfoot.start();
    }
    
    private void draw()
    {
        GreenfootImage bg = getBackground();
        bg.setColor(new Color(0, 0, 150));
        bg.fill();
        
        bg.setColor(Color.BLACK);
        bg.setFont(new Font("Arial", Font.BOLD, 36));
        bg.drawString("CENTRIPETAL FORCE", 150, 40);
        
        bg.drawString("=", 310, 135);
        bg.fillRect(392, 123, 40, 5);
        
        bg.setFont(new Font("Arial", Font.BOLD, 20));
        bg.drawString("2", 422, 85);
        
        bg.setFont(new Font("Arial", Font.ITALIC, 18));
        bg.drawString("Created by GershiBelshi", 495, 595);
        
        setBackground(bg);
    }
}
