import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Variable here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Variable extends Actor
{
    public static final int SIZE = 32;
    private String character;
    private double value;
    private double rangeMin;
    private double rangeMax;
    private double step;
    private Centripetal centripetal;
    private int num;
    private GreenfootImage image;
    
    public Variable()
    {
        this("F", 0.5, 0.0, 1.0, 0.1, 0);
    }
    
    public Variable(String character, double value, double rangeMin, double rangeMax, double step, int num)
    {
        this.character = character;
        this.value = value;
        this.rangeMin = rangeMin;
        this.rangeMax = rangeMax;
        this.step = step;
        this.num = num;
        draw();
    }
    
    public void setCentripetal(Centripetal centripetal) {this.centripetal = centripetal;}
    
    public void increase()
    {
        if(centripetal.getVariable()==num) {return;}
        value += step;
        if(value > rangeMax) {value = rangeMax;}
        draw();
        if(num==0) {centripetal.setForce(value);}
        if(num==1) {centripetal.setMass(value);}
        if(num==2) {centripetal.setVelocity(value);}
        if(num==3) {centripetal.setRadius(value);}
    }
    
    public void decrease()
    {
        if(centripetal.getVariable()==num) {return;}
        value -= step;
        if(value < rangeMin) {value = rangeMin;}
        draw();
        if(num==0) {centripetal.setForce(value);}
        if(num==1) {centripetal.setMass(value);}
        if(num==2) {centripetal.setVelocity(value);}
        if(num==3) {centripetal.setRadius(value);}
    }
    
    public double getValue() {return value;}
    
    public void setValue(double value)
    {
        //if(centripetal.getVariable()==num) {return;}
        this.value = value;
        draw();
        //if(num==0) {centripetal.setForce(value);}
        //if(num==1) {centripetal.setMass(value);}
        //if(num==2) {centripetal.setVelocity(value);}
        //if(num==3) {centripetal.setRadius(value);}
    }
    
    public void draw()
    {
        image = new GreenfootImage(50, 50);
        image.setColor(getColor());
        image.setFont(new Font("Arial", Font.BOLD, SIZE));
        image.drawString(character, SIZE/2, SIZE);
        setImage(image);
    }
    
    private Color getColor()
    {
        int red = (int)((rangeMax-value)/(rangeMax-rangeMin)*255);
        if(red>255){red = 255;} if(red<0) {red = 0;}
        int green = (int)((value-rangeMin)/(rangeMax-rangeMin)*255);
        if(green>255){green = 255;} if(green<0) {green = 0;}
        return new Color(red, green, 0);
    }
}